var Sina = {
	reg: function() {
		var sinaWeiBo = api.require('sinaWeiBo');
		sinaWeiBo.cancelAuth(function(ret, err) {
			if (ret.status) {
				api.alert({
					msg: '登出成功'
				});
			} else {
				api.alert({
					msg: err.msg
				});
			}
		});
	},
	auth: function() {
		var sinaWeiBo = api.require('sinaWeiBo');
		sinaWeiBo.auth(function(ret, err) {
			if (ret.status) {
				var token = ret.accessToken;
				var uID = ret.userID;
				localStorage.setItem('accessToken', token);
				localStorage.setItem('userID', uID);
				Sina.send();
			} else {
				api.alert({
					msg: 'auth----' + err.msg
				});
			}
		});
	},
	send: function() {
		var sinaWeiBo = api.require('sinaWeiBo'),
			imageUrl = 'widget://image/mtapp_ico.jpg',
			contentType = 'text',
			description = '',
			title = '美天天气预警信息',
			text = '#美天天气#' + city + '，' + name + '，发布时间：' + publicDate,
			thumbUrl = 'widget://image/mtapp_ico.jpg',
			webpageUrl = web_page_url,
			jsonMedia = {
				title: title,
				description: description,
				thumbUrl: thumbUrl,
				webpageUrl: webpageUrl
			};
		sinaWeiBo.sendRequest({
			contentType: contentType,
			text: text,
			imageUrl: imageUrl,
			media:jsonMedia
		}, function(ret, err) {
			if (ret.status) {
				api.alert({
					title: '发表微博',
					msg: '发表成功',
					buttons: ['确定']
				}, function(ret, err) {
					if (ret.buttonIndex == 1) {
						$('#mess').hide();
						$('#mask').hide();
					}
				});
			} else {
				api.alert({
					title: '发表微博',
					msg: '发表失败',
					buttons: ['确定']
				});
			};
		});
	},
	getSinaUserInfo: function() {
		var sinaWeiBo = api.require('sinaWeiBo');
		sinaWeiBo.getUserInfo({}, function(ret, err) {
			if (ret.status) {
				send();
			} else {
				api.alert({
					msg: err.msg
				});
			}
		});
	}
};

var WeiXin = {
	getUsersInfomation: function() {
		var weiXin = api.require('weiXin');
		weiXin.getUserInfo(function(ret, err) {
			if (ret.status) {
				WeiXin.sendReq();
			} else {
				api.alert({
					msg: err.msg
				});
			}
		});
	},
	reg: function() {
		var weiXin = api.require('weiXin');
		weiXin.registerApp(function(ret, err) {
			if (ret.status) {
				WeiXin.loginWeiXin();
			} else {
				api.alert({
					msg: '注册失败'
				});
			}
		});
	},
	loginWeiXin: function() {
		var weiXin = api.require('weiXin');
		weiXin.auth(function(ret, err) {
			if (ret.status) {
				var token = ret.token;
				localStorage.setItem('wxToken', token);
				WeiXin.getUsersInfomation();
			} else {
				api.alert({
					msg: err.msg
				});
			}
		});
	},
	sendReq: function() {
		var weiXin = api.require('weiXin'),
			scene = 'timeline',
			contentType = 'text',
			title = '美天天气预警信息',
			description = '#美天天气#' + city + '，' + name + '，发布时间：' + publicDate,
			thumbUrl = 'widget://image/mtapp_ico.jpg',
			contentUrl = web_page_url,
			contentUrlI = web_page_url,
			contentUrlV = web_page_url,
			URL = null;
		if (contentType == 'image') {
			URL = contentUrlI;
		} else if (contentType == 'video') {
			URL = contentUrlV;
		} else if (contentType == 'music') {
			URL = contentUrlM;
		} else {
			URL = contentUrl;
		}
		weiXin.sendRequest({
			scene: scene,
			contentType: contentType,
			title: title,
			description: description,
			thumbUrl: thumbUrl,
			contentUrl: URL
		}, function(ret, err) {
			if (ret.status) {
				api.alert({
					title: '发表微信',
					msg: '发表成功',
					buttons: ['确定']
				}, function(ret, err) {
					if (ret.buttonIndex == 1) {
						$('#mess').hide();
						$('#mask').hide();
					}
				});
			} else {
				api.alert({
					title: '发表微信',
					msg: '发布失败',
					buttons: ['确定']
				});
			};
		});
	},
	refresh: function() {
		var weiXin = api.require('weiXin');
		weiXin.refreshToken(function(ret, err) {
			if (ret.status) {
				WeiXin.loginWeiXin();
			} else {
				api.alert({
					msg: err.msg
				});
			}
		});
	}
};

function getWarning(city) {
	var url = 'http://ott.atianqi.com:7030/getweatherwarning';
	var params = {
		"reqhead": {
			"servicecode": "OTTTV",
			"distributor": "SNM",
			"clienttype": "PC",
			"clientid": "JHSG7328f",
			"clientver": "1.0.1",
			"devicetype": "",
			"clientos": "andiod_4.3.1"
		},
		"reqbody": {
			"cityname": city,
			"querydate": new Date().format("yyyy-MM-dd hh:mm:ss")
		}
	};
	$.ajax({
		type: "post",
		url: url,
		contentType: 'application/json;charset=UTF-8',
		dataType: 'json',
		data: JSON.stringify(params),
		success: function(data) {
			if (data.resphead.resultCode === '0000') {
				if (data.respbody[0]) {
					var warning = data.respbody[0];
					publicDate = warning.issueDt;
					name = warning.alarmName + warning.alarmLevel + '警告';
					icon = 'image/warning/' + Font[warning.alarmName] + Color[warning.alarmLevel] + '.png';
					$('#waring_icon').html('<img width="140" src="' + icon + '" />');
					$('#waring_name').html(name);
					var issueDt = warning.issueDt.split(' ');
					var d = issueDt[0].split('-');
					var t = issueDt[1].split(':');
					$('#wtitle').html('内容发布于' + d[1] + '月' + d[2] + '日 ' + t[0] + ':' + t[1]);
				}
			}
		},
		error: function(data) {}
	});
}

var web_page_url = '',
	city = '',
	name = '',
	icon = '',
	publicDate = '';
var Font = {
	'冰雹':'bb',
	'暴雨':'by',
	'道路结冰':'dljb',
	'大雾':'dw',
	'高温':'gw',
	'寒冷':'hl',
	'灰霾':'hm',
	'雷雨大风':'lydf',
	'森林火险':'slhx',
	'台风':'tf',
};

var Color = {
	'蓝色':'b',
	'橙色':'o',
	'红色':'r',
	'白色':'w',
	'黄色':'y',
}
window.apiready = function() {
	$api.fixIos7Bar($api.byId('weath_header'));
	$api.fixIos7Bar($api.byId('goTo'));
	$api.fixIos7Bar($api.byId('share'));
	$api.fixIos7Bar($api.byId('main'));
	city = decodeURIComponent($.getQueryStr(window.location.href, 'city'))
	$('#city').html(city);
	getWarning(city);
	$('#share').on('touchend', function() {
		$('#mess').toggle();
		$('#mask').toggle();
	});
	
	$('#goTo').on('tap',function() {
		history.back();
	})

	$('.mess_share_txt a').on('touchend', function(e) {
		var sysType = api.systemType;
		var lable = $(this).attr('data-lable');
		if (lable === '2') {
			var token = localStorage.getItem('accessToken');
			var uID = localStorage.getItem('userID');
			if (token && uID) {
				Sina.send();
			} else {
				var appBundle;
				if (api.systemType == 'ios') {
					Sina.auth();
					return;
				} else {
					appBundle = 'com.sina.weibo';
				}
				api.appInstalled({
					appBundle: appBundle
				}, function(ret, err) {
					if (ret.installed) {
						Sina.auth();
					} else {
						Sina.send();
					}
				});
			}
		} else if (lable === '1') {
			if (sysType == 'android') {
				var wxToken = localStorage.getItem('wxToken');
				if (wxToken) {
					WeiXin.sendReq();
				} else {
					WeiXin.reg();
				}
			} else {
				WeiXin.reg();
			}
		} else {
			var accessToken = localStorage.getItem('qqToken');
			var openId = localStorage.getItem('openId');
			if (accessToken && openId) {
				QQ.shareToqqnew();
			} else {
				QQ.startLogin();
			}
		}
	});
}