var File = {
	open: function(path, callback) {
		var fs = api.require('fs');
		fs.open({
			path: path,
			flags: 'read_write'
		}, function(ret, err) {
			if (typeof callback === 'function') {
				callback({
					status: ret.status,
					fd: ret.fd,
					code: err.code,
					msg: err.msg
				});
			}
		});
	},
	create: function(path, callback) {
		var fs = api.require('fs');
		fs.createFile({
			path: path
		}, function(ret, err) {
			if (typeof callback === 'function') {
				callback({
					status: ret.status,
					code: err.code,
					msg: err.msg
				});
			}
		});
	},
	exist: function(path, callback) {
		var obj = api.require('fs');
		obj.exist({
			path: path
		}, function(ret, err) {
			if (typeof callback === 'function') {
				callback(ret.exist);
			}
		});
	},
	read: function(fd, callback) {
		var fs = api.require('fs');
		fs.read({
			fd: fd,
			offset: 0,
			length: 0
		}, function(ret, err) {
			if (ret.status) {
				if (typeof callback === 'function') {
					callback(ret.data);
				}
			} else {
//				api.alert({
//					msg: err.msg
//				});
			}
		});
	},
	write: function(fd, data, callback) {
		var fs = api.require('fs');
		fs.write({
			fd: fd,
			data: data,
			offset: 0,
			overwrite: true
		}, function(ret, err) {
			if (typeof callback === 'function') {
				callback(ret.status);
			}
		});
	}
}

/**
 * 判断是否有网络
 * @param {Object} callback
 */
function isHasConnection(callback) {
	var connectionType = api.connectionType
	if ('none' === connectionType) {
		api.refreshHeaderLoadDone();
		toast('网络不可用','bottom');
	} else {
		if (typeof callback === 'function') {
			callback();
		}
	}
}

function toast(msg, location) {
	api.toast({
		msg: msg,
		duration: 3000//,
		//location: location || 'middle'
	});
}

function getCurData(data, curPage) {
	var totalPage = Math.ceil(data.length / 12);
	if (curPage > totalPage) {
		return [];
	}
	var endNum = curPage < totalPage ? curPage * 12 : data.length;
	return data.slice((curPage - 1) * 12, endNum);
}

function getAllId(data) {
	var arrId = [];
	for (var i = 0; i < data.length; i++) {
		arrId.push(data[i].id);
	}
	return arrId.join('&');
}

function filterData(data, strId) {
	var arrData = [];
	for (var i = 0; i < data.length; i++)　 {
		if (strId.indexOf(data[i].id) == -1) {
			arrData.push(data[i]);
		}
	}
	return arrData;
}