/*验证长度（包括中英文）*/
function checkFullLength(str, leng) {
    ///<summary>获得字符串实际长度，中文2，英文1</summary>
    ///<param name="str">要获得长度的字符串</param>
    var realLength = 0, len = str.length, charCode = -1;
    for (var i = 0; i < len; i++) {
        charCode = str.charCodeAt(i);
        if (charCode >= 0 && charCode <= 128) realLength += 1;
        else realLength += 2;
    }
    if (realLength > leng) {
        return false;
    }
    else {
        return true;
    }
};
/**验证长度 str 要验证的字符，字符长度**/
function checklength(str, leng) {
    if (str.length < leng) {
        return false;
    }
    else
        return true;
}
/**验证字符是否为空或者全部都是空格 **/
function checkstr(str) {
    //    if(str.length==0)
    //    {
    //        return false;
    //    }
    //    else
    //    return true;
    if (str == "") return false;
    var regu = "^[ ]+$";
    var re = new RegExp(regu);
    return !re.test(str);
}
/**验证Email**/
function isEmail(str) {
    if (str.search(/^\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/) != -1)
        return true;
    else
        return false
}
/**数字检查**/
function isNum(str) {
    return str.match(/\D/) == null

}
/**检查是否为电话号码**/
function isNumber(String) {
    var Letters = "1234567890-"; /**可以自己增加可输入值**/
    var i;
    var c;
    if (String.charAt(0) == '-')
        return false;
    if (String.charAt(String.length - 1) == '-')
        return false;
    for (i = 0; i < String.length; i++) {
        c = String.charAt(i);
        if (Letters.indexOf(c) < 0)
            return false;
    }
    return true;
}
/**中文值检测**/
function isChinese(name) {
    if (name.length == 0)
        return false;
    for (i = 0; i < name.length; i++) {
        if (name.charCodeAt(i) > 128)
            return true;
    }
    return false;
}
/**英文值检测**/
function isEnglish(name) {
    if (name.length == 0)
        return false;
    for (i = 0; i < name.length; i++) {
        if (name.charCodeAt(i) > 128)
            return false;
    }
    return true;
}
/**判断用户名是否为数字字母下滑线**/
function username(str) {
    var reg = /[^A-Za-z0-9_]/g
    if (reg.test(str)) {
        return (false);
    } else {
        return (true);
    }
}

/**判断网址**/
function IsURL(str_url) {
    var re = new RegExp("((^http)|(^https)|(^ftp)):\/\/(\\w)+\.(\\w)+");
    if (re.test(str_url)) {
        return (true);
    }
    else {
        return (false);
    }
}
/**移动号码验证**/
/**134、135、136、137、138、139、147、150、151、152、157、158、159、182、188**/
function ChinaMobile(value) {
    /**移动号段：134-9，147，150-2，157-9，187-8**/
    var res = /^[1](3[4-9]{1}|47|5[0-2]{1}|5[7-9]{1}|8[2-4]{1}|8[7-8]{1})\d{8}$/;
    var re = new RegExp(res);
    if (re.test(value)) {
        return true;
    }
    return false;
}

/**联通号码验证**/
function ChinaUnicom(value) {
    /**联通号段：130-2，155-6，185-6**/
    var res = /^[1](3[0-2]{1}|5[5-6]{1}|8[5-6]{1})\d{8}$/;
    var re = new RegExp(res);
    if (re.test(value)) {
        return true;
    }
    return false;
}

/**电信号码验证**/
function ChinaTelecom(value) {
    /**电信号段：133，153，180，189，177或者固话	**/
    var res = /^(([1](33|53|80|81|89|77)\d{8})|([0][1-9]{1,3}\d{7,8}))$/;
    var re = new RegExp(res);
    if (re.test(value)) {
        return true;
    }
    return false;
}

/**其他号码验证（阿里等）**/
function ChinaTeleOther(value) {
    /**电信号段：170	**/
    var res = /^[1](7[0]{1})\d{8}$/;
    var re = new RegExp(res);
    if (re.test(value)) {
        return true;
    }
    return false;
}

/**全角转换半角   电话号码格式转化**/
function CtoH(obj) {
    var str = obj.value;
    var result = "";
    for (var i = 0; i < str.length; i++) {
        if (str.charCodeAt(i) == 12288) {
            result += String.fromCharCode(str.charCodeAt(i) - 12256);
            continue;
        }
        if (str.charCodeAt(i) > 65280 && str.charCodeAt(i) < 65375)
            result += String.fromCharCode(str.charCodeAt(i) - 65248);
        else result += String.fromCharCode(str.charCodeAt(i));
    }
    obj.value = result;
}

/**检测日期是否正确开始**/
function dateCheck(str) {
    var re = new RegExp("^([0-9]{4})[.-]{1}([0-9]{1,2})[.-]{1}([0-9]{1,2})$");
    var ar;
    if ((ar = re.exec(str)) != null) {
        var i;
        i = parseFloat(ar[1]);
        if (i <= 0 || i > 9999)
        { return false; }
        i = parseFloat(ar[2]);
        if (i <= 0 || i > 12)
        { return false; }
        i = parseFloat(ar[3]);
        if (i <= 0 || i > 31)
        { return false; }
    }
    else
    { return false; }
    return true;
}

function isIdCardNo(idcard) {
    idcard = idcard.toLocaleUpperCase();
    var Errors = new Array(
	"验证通过!",
	"身份证号码位数不对!",
	"身份证号码出生日期超出范围或含有非法字符!",
	"身份证号码校验错误!",
	"身份证地区非法!"
	);
    var area = { 11: "北京", 12: "天津", 13: "河北", 14: "山西", 15: "内蒙古", 21: "辽宁", 22: "吉林", 23: "黑龙江", 31: "上海", 32: "江苏", 33: "浙江", 34: "安徽", 35: "福建", 36: "江西", 37: "山东", 41: "河南", 42: "湖北", 43: "湖南", 44: "广东", 45: "广西", 46: "海南", 50: "重庆", 51: "四川", 52: "贵州", 53: "云南", 54: "西藏", 61: "陕西", 62: "甘肃", 63: "青海", 64: "宁夏", 65: "新疆", 71: "台湾", 81: "香港", 82: "澳门", 91: "国外" }
    var idcard, Y, JYM;
    var S, M;
    var idcard_array = new Array();
    idcard_array = idcard.split("");
    /** 地区检验**/
    if (area[parseInt(idcard.substr(0, 2))] == null) return false; /** Errors[4];
/** 身份号码位数及格式检验**/
    switch (idcard.length) {
        case 15:
            if ((parseInt(idcard.substr(6, 2)) + 1900) % 4 == 0 || ((parseInt(idcard.substr(6, 2)) + 1900) % 100 == 0 && (parseInt(idcard.substr(6, 2)) + 1900) % 4 == 0)) {
                ereg = /^[1-9][0-9]{5}[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|[1-2][0-9]))[0-9]{3}$/; /** 测试出生日期的合法性**/
            } else {
                ereg = /^[1-9][0-9]{5}[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|1[0-9]|2[0-8]))[0-9]{3}$/; /** 测试出生日期的合法性**/
            }
            if (ereg.test(idcard))
                return true; /** Errors[0];**/
            else return false; /** Errors[2];**/
            break;
        case 18:
            /** 18位身份号码检测**/
            /** 出生日期的合法性检查**/
            /** 闰年月日:((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|[1-2][0-9]))**/
            /** 平年月日:((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|1[0-9]|2[0-8]))**/
            if (parseInt(idcard.substr(6, 4)) % 4 == 0 || (parseInt(idcard.substr(6, 4)) % 100 == 0 && parseInt(idcard.substr(6, 4)) % 4 == 0)) {
                ereg = /^[1-9][0-9]{5}(19|20)[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|[1-2][0-9]))[0-9]{3}[0-9Xx]$/; /** 闰年出生日期的合法性正则表达式**/
            } else {
                ereg = /^[1-9][0-9]{5}(19|20)[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|1[0-9]|2[0-8]))[0-9]{3}[0-9Xx]$/; /** 平年出生日期的合法性正则表达式**/
            }
            if (ereg.test(idcard)) {/**测试出生日期的合法性**/
                /** 计算校验位**/
                S = (parseInt(idcard_array[0]) + parseInt(idcard_array[10])) * 7
		+ (parseInt(idcard_array[1]) + parseInt(idcard_array[11])) * 9
		+ (parseInt(idcard_array[2]) + parseInt(idcard_array[12])) * 10
		+ (parseInt(idcard_array[3]) + parseInt(idcard_array[13])) * 5
		+ (parseInt(idcard_array[4]) + parseInt(idcard_array[14])) * 8
		+ (parseInt(idcard_array[5]) + parseInt(idcard_array[15])) * 4
		+ (parseInt(idcard_array[6]) + parseInt(idcard_array[16])) * 2
		+ parseInt(idcard_array[7]) * 1
		+ parseInt(idcard_array[8]) * 6
		+ parseInt(idcard_array[9]) * 3;
                Y = S % 11;
                M = "F";
                JYM = "10X98765432";
                M = JYM.substr(Y, 1); /** 判断校验位**/
                if (M == idcard_array[17]) return true; /** Errors[0]; /**检测ID的校验位**/
                else return false; /** Errors[3];**/
            }
            else return false; /** Errors[2];**/
            break;
        default:
            return false; /** Errors[1];**/
            break;
    }
}
function checkDate(date) {

    return true;
}

//公共方法和input新增属性
//data-old-value 旧值
//data-type 数据类型
//data-display-format 显示日期格式
//data-store-format 存储日期格式
//data-char-case大小写
//data-place-holder提示文字
//data-tip-orientation提示框方向
function CommonClass() {

}

CommonClass.GetMonthHead = function () {
    var monHead = new Array(12); //定义阳历中每个月的最大天数
    monHead[0] = 31;
    monHead[1] = 28;
    monHead[2] = 31;
    monHead[3] = 30;
    monHead[4] = 31;
    monHead[5] = 30;
    monHead[6] = 31;
    monHead[7] = 31;
    monHead[8] = 30;
    monHead[9] = 31;
    monHead[10] = 30;
    monHead[11] = 31;
    return monHead;
};

CommonClass.getCurrentYear = function () {
    return new Date().getFullYear();
};

CommonClass.getCurrentMonth = function () {
    return new Date().getMonth() + 1;
};

CommonClass.IsPinYear = function (year)            //判断是否闰平年
{
    if (0 == year % 4 && ((year % 100 != 0) || (year % 400 == 0))) return true;
    else return false;
};

CommonClass.GetMonthCount = function (year, month)  //闰年二月为29天
{
    var c = GetMonthHead()[month - 1];
    if ((month == 2) && IsPinYear(year)) c++;
    return c;
};
//整数
CommonClass.checkIntergeWide = function (strValue) {
    if (!strValue || strValue == "") return false;
    var intergeReg = /^-?\d*$/;
    var reg = strValue.match(intergeReg);
    if (reg) {
        return false;
    } else {
        return true;
    }
};
//浮点数
CommonClass.checkFloatWide = function (strValue) {
    if (!strValue || strValue == "") return false;
    var flostReg = /^-?[0-9]+.?\d*$/;
    var reg = strValue.match(flostReg);
    if (reg) {
        return false;
    } else {
        return true;
    }
};
//中文验证
CommonClass.checkChineseWide = function (strValue) {
    if (!strValue || strValue == "") return false;
    var chineseReg = /^([u4e00-u9fa5]|[ufe30-uffa0])*$/gi;
    var reg = strValue.match(chineseReg);
    if (reg) {
        return false;
    } else {
        return true;
    }
};
//手机验证
CommonClass.checkIsTelephoneWide = function (strValue) {
    if (!strValue || strValue == "") return false;
    var telephoneReg = /^1[3|4|5|8][0-9]\d{8}$/;
    var reg = strValue.match(telephoneReg);
    if (reg) {
        return false;
    } else {
        return true;
    }
};
//IP验证
CommonClass.checkIPAddressWide = function (strValue) {
    if (!strValue || strValue == "") return false;
    var ipReg = /^(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])$/;
    var reg = strValue.match(ipReg);
    if (reg) {
        return false;
    } else {
        return true;
    }
};
//邮编验证
CommonClass.checkZipWide = function (strValue) {
    if (!strValue || strValue == "") return false;
    var zipReg = /^[1-9][0-9]{5}$/;
    var reg = strValue.match(zipReg);
    if (reg) {
        return false;
    } else {
        return true;
    }
};
//Email验证
CommonClass.checkEmailWide = function (strValue) {
    if (!strValue || strValue == "") return false;
    var zipReg = /\w@\w*\.\w/;
    var reg = strValue.match(zipReg);
    if (reg) {
        return false;
    } else {
        return true;
    }
};
//日期验证
CommonClass.checkDateWide = function (strValue) {
    if (!strValue || strValue == "") return false;
    var zipReg = /^\/d{8}$/;
    var reg = strValue.match(zipReg);
    if (reg) {
        return false;
    } else {
        return true;
    }
};
//提示 0:显示 1：隐藏
CommonClass.getPlaceHolder = function (type, id, value) {
    switch (type) {
        case 0:
            if (value && $(id).val() == "") {
                $(id).val(value);
                $(id).css("color", "silver");
                $(id).removeClass("valid");
            }
            break;
        case 1:
            if (value && $(id).val() == value)
                $(id).val("");
            $(id).css("color", "black");

            break;
        default:
            break;
    }
};
//orientation 箭头方向
CommonClass.showError = function (id, value, orientation) {
    $(id).removeClass("valid");
    $("#toolTip_" + $(id).attr("id")).remove();
    var top = $(id).offset().top + 8;
    var left = $(id).offset().left;
    var width = $(id).width();
    var height = $(id).height();
    var errorDialog = $("<div id=\"toolTip_" + $(id).attr("id") + "\" class=\"toolTip\"></div>").append("<div class=\"toolTipTop " + orientation + "\"></div><div class=\"toolTipBotton \">" + value + "</div>");
    var dialogWidth = 40; //箭头宽度高度大小
    $("body").append(errorDialog);
    switch (orientation) {
        case "left":
            errorDialog.css({ top: top - errorDialog.height() / 2, left: left + width + dialogWidth });
            break;
        case "right":
            errorDialog.css({ top: top - errorDialog.height() / 2, left: left - errorDialog.width() - dialogWidth });
            break;
        case "top":
            errorDialog.css({ top: top - errorDialog.height + dialogWidth, left: left + (width - errorDialog.width()) / 2 });
            break;
        case "bottom":
            errorDialog.css({ top: top - errorDialog.height() - dialogWidth, left: left + (width - errorDialog.width()) / 2 });
            break;
        default:
    }
    errorDialog.css({ position: "absolute" });
};
//关闭提示框
CommonClass.CloseToolTip = function (id) {
    $(id).removeClass("invalid");
    if ($(id).val() != $(id).attr("data-place-holder")) {
        $(id).addClass("valid");
    }
    if ($("#toolTip_" + $(id).attr("id")).length) {
        $("#toolTip_" + $(id).attr("id")).remove();
        return;
    }
};
//验证
CommonClass.Invail = function (id, orientation) {
    var error = [];
    $("input[required]").each(function (index, ui) {
        var i = $(ui);
        if (!checkstr(i.val()) || i.val() == i.attr("data-place-holder") || i.hasClass("invalid")) {
            i.addClass("invalid");
            error.push(i.attr("data-place-holder"));
        }
    });
    if (error.length > 0) {
        //CommonClass.showError(id, error.join("<br/>"), orientation);
        return true;
    } else {
        return false;
    }
};
//data-old-value 旧值
//data-type 数据类型
//data-display-format 显示日期格式
//data-store-format 存储日期格式
//data-char-case大小写
//data-place-holder提示文字
//data-tip-orientation提示框方向
CommonClass.InstallInputDefaultListener = function () {
    $.map($("input[type=text]"), function (ui, index) {
        var a = $(ui);
        if (a.attr("data-char-case")) {
            a.css("text-transform", a.attr("data-char-case").toString().toLowerCase());
        }
        var placeHolder = a.attr("data-place-holder");
        var tipOrientation = "left";
        CommonClass.getPlaceHolder(0, ui, placeHolder);

        if (a.attr("data-type")) {
            var dataType = a.attr("data-type");
            switch (dataType) {
                case "int":
                    a.attr("maxLength", "10");
                    a.blur(function (e) {
                        if (CommonClass.checkIntergeWide($(this).val())) {
                            CommonClass.showError(this, "请输入数字", $(this).attr("data-tip-orientation") || tipOrientation);
                            $(this).focus();
                            return false;
                        }
                        CommonClass.CloseToolTip(this);
                        return true;
                    });
                    a.keypress(function (e) {
                        var keyCode = e.keyCode || e.which;
                        if ((keyCode < 48 || keyCode > 57) && keyCode != 8 && keyCode != 22 && keyCode != 13 && keyCode != 45)
                            return false;
                        return true;
                    });
                    break;
                case "float":
                    a.attr("maxLength", "10");
                    a.blur(function (e) {
                        if (CommonClass.checkFloatWide($(this).val())) {
                            CommonClass.showError(this, "请输入浮点数", $(this).attr("data-tip-orientation") || tipOrientation);
                            $(this).focus();
                            return false;
                        }
                        CommonClass.CloseToolTip(this);
                        return true;
                    });
                    a.keypress(function (e) {
                        var keyCode = e.keyCode || e.which;
                        if (keyCode != 13 && keyCode != 45 && keyCode != 46 && (keyCode < 48 || keyCode > 57))
                            return false;
                        return true;
                    });
                    break;
                case "telephone":
                    a.blur(function (e) {
                        if (CommonClass.checkIsTelephoneWide($(this).val())) {
                            CommonClass.showError(this, "请输入正确的手机号码", $(this).attr("data-tip-orientation") || tipOrientation);
                            $(this).focus();
                            return false;
                        }
                        CommonClass.CloseToolTip(this);
                        return true;
                    });
                    a.keypress(function (e) {
                        var keyCode = e.keyCode || e.which;
                        if ((keyCode < 48 || keyCode > 57) && keyCode != 8 && keyCode != 22 && keyCode != 13 && keyCode != 45)
                            return false;
                        return true;
                    });
                    break;
                case "email":
                    a.blur(function (e) {
                        if (CommonClass.checkEmailWide($(this).val())) {
                            CommonClass.showError(this, "请输入正常的Email地址", $(this).attr("data-tip-orientation") || tipOrientation);
                            $(this).focus();
                            return false;
                        }
                        CommonClass.CloseToolTip(this);
                        return true;
                    });
                    break;
                case "date":
                    a.attr("maxLength", "8");
                    a.keypress(function (e) {
                        var keyCode = e.keyCode || e.which;
                        if (keyCode != 13 && keyCode != 47 && keyCode != 32 && keyCode != 45 && keyCode != 58 && (keyCode < 48 || keyCode > 57))
                            return false;
                        return true;
                    });
                    a.blur(function (e) {
                        if (CommonClass.checkDateWide($(this).val())) {
                            CommonClass.showError(this, "请输入日期，日期格式为20140101", $(this).attr("data-tip-orientation") || tipOrientation);
                            $(this).focus();
                            CommonClass.getPlaceHolder(0, ui, placeHolder);
                            return false;
                        }
                        CommonClass.CloseToolTip(this);
                        CommonClass.getPlaceHolder(0, ui, placeHolder);
                        return true;
                    });
                    break;
                default:
            }
        }
        a.focus(function () {
            CommonClass.getPlaceHolder(1, this, placeHolder);
        });
        a.blur(function () {
            var e = $(this);
            if (e.attr("data-verif-func")) {
                if (!e.attr("data-verif-func")()) {
                    CommonClass.showError(this, e.attr("data-verif-error") || placeHolder, e.attr("data-tip-orientation") || tipOrientation);
                    return false;
                }
            }
            if (e.attr("required") || e.attr("required") == "") {
                if (!checkstr(e.val()) || e.val() == e.attr("data-place-holder") || ($("#toolTip_" + e.attr("id")).length)) {
                    e.addClass("invalid");
                    e.removeClass("valid");
                } else {
                    e.addClass("valid");
                    e.removeClass("invalid");
                }
            }
            CommonClass.getPlaceHolder(0, ui, placeHolder);
        });
    });
}